## ros-foxy-robot-state-publisher 2.4.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(robot_state_publisher)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(builtin_interfaces REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(kdl_parser REQUIRED)
find_package(orocos_kdl REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(urdf REQUIRED)
find_package(urdfdom_headers REQUIRED)

include_directories(include)

add_library(
  ${PROJECT_NAME}_node SHARED
  src/robot_state_publisher.cpp)
ament_target_dependencies(${PROJECT_NAME}_node
  builtin_interfaces
  geometry_msgs
  kdl_parser
  orocos_kdl
  rclcpp
  rclcpp_components
  sensor_msgs
  std_msgs
  tf2_ros
  urdf
)

rclcpp_components_register_node(${PROJECT_NAME}_node
  PLUGIN "robot_state_publisher::RobotStatePublisher"
  EXECUTABLE robot_state_publisher)

install(
  TARGETS
  ${PROJECT_NAME}_node
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(DIRECTORY include/
  DESTINATION include)

install(DIRECTORY launch urdf
  DESTINATION share/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest REQUIRED)
  find_package(launch_testing_ament_cmake REQUIRED)
  ament_find_gtest()

  include_directories(${GTEST_INCLUDE_DIRS})

  add_executable(test_two_links_fixed_joint test/test_two_links_fixed_joint.cpp)
  ament_target_dependencies(test_two_links_fixed_joint
    rclcpp
    tf2_ros
  )
  target_link_libraries(test_two_links_fixed_joint ${GTEST_LIBRARIES})
  add_launch_test(test/two_links_fixed_joint-launch.py
    ARGS "test_exe:=$<TARGET_FILE:test_two_links_fixed_joint>")

  add_executable(test_two_links_fixed_joint_prefix test/test_two_links_fixed_joint_prefix.cpp)
  ament_target_dependencies(test_two_links_fixed_joint_prefix
    rclcpp
    tf2_ros
  )
  target_link_libraries(test_two_links_fixed_joint_prefix ${GTEST_LIBRARIES})
  add_launch_test(test/two_links_fixed_joint_prefix-launch.py
    ARGS "test_exe:=$<TARGET_FILE:test_two_links_fixed_joint_prefix>")

  add_executable(test_two_links_moving_joint test/test_two_links_moving_joint.cpp)
  ament_target_dependencies(test_two_links_moving_joint
    rclcpp
    sensor_msgs
    tf2_ros
  )
  target_link_libraries(test_two_links_moving_joint ${GTEST_LIBRARIES})
  add_launch_test(test/two_links_moving_joint-launch.py
    ARGS "test_exe:=$<TARGET_FILE:test_two_links_moving_joint>")
endif()

ament_export_dependencies(builtin_interfaces orocos_kdl rclcpp sensor_msgs std_msgs tf2_ros urdf)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME}_node)
ament_package()

=== debian/changelog ===
ros-foxy-robot-state-publisher (2.4.5-1focal) focal; urgency=high

  * Restore tf frame prefix support for ROS 2 (#159 <https://github.com/ros/robot_state_publisher/issues/159>) (#170 <https://github.com/ros/robot_state_publisher/issues/170>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 04 Aug 2021 00:00:00 -0000

ros-foxy-robot-state-publisher (2.4.2-1focal) focal; urgency=high

  * clean up license to be standard bsd 3 clause (#130 <https://github.com/ros/robot_state_publisher/issues/130>)
  * Update the maintainers. (#151 <https://github.com/ros/robot_state_publisher/issues/151>)
  * Contributors: Chris Lalancette, Tully Foote

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 25 Jan 2021 00:00:00 -0000

ros-foxy-robot-state-publisher (2.4.1-1focal) focal; urgency=high

  * fix types in range loops to avoid copy due to different type (#143 <https://github.com/ros/robot_state_publisher/issues/143>)
  * Make sure not to crash on an invalid URDF. (#141 <https://github.com/ros/robot_state_publisher/issues/141>)
  * Contributors: Chris Lalancette, Dirk Thomas

 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 28 Sep 2020 00:00:00 -0000

ros-foxy-robot-state-publisher (2.4.0-1focal) focal; urgency=high

  * Replace deprecated launch_ros usage (#137 <https://github.com/ros/robot_state_publisher/issues/137>)
  * code style only: wrap after open parenthesis if not in one line (#129 <https://github.com/ros/robot_state_publisher/issues/129>)
  * Refactor the ROS 2 code to be more modern (#126 <https://github.com/ros/robot_state_publisher/issues/126>)
  * Switch to using TARGET_FILE to find the binary targets on Windows.
  * Fix tests on Windows.
  * Make the error message much nicer on Windows.
  * robot_state_publisher_node -> robot_state_publisher
  * Fix test build on Windows.
  * Get rid of redundant declaration.
  * Guard against negative publish_frequencies.
  * Switch to modern launch_testing ReadyToTest.
  * Add testing to robot_state_publisher.
  * Update some example launch files.
  * Implement the ability to change the parameters on the fly.
  * Fix silly bug while computing the publish interval.
  * Refactor to have a "setup" function during the constructor and later on during the parameter setup.
  * Mark things as explicit and final.
  * Update the documentation.
  * Make robot_state_publisher composable.
  * Contributors: Chris Lalancette, Dirk Thomas, Jacob Perron

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 30 Apr 2020 00:00:00 -0000

ros-foxy-robot-state-publisher (2.3.1-1focal) focal; urgency=high

  * Switch the license back to BSD. (#121 <https://github.com/ros/robot_state_publisher/issues/121>)
  * Contributors: Chris Lalancette

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-foxy-robot-state-publisher (2.3.0-1focal) focal; urgency=high

  * Install include directories (#31 <https://github.com/ros2/robot_state_publisher/issues/31>)
  * Publish URDF string on startup (#24 <https://github.com/ros2/robot_state_publisher/issues/24>)
  * Contributors: Patrick Beeson, Poh Zhi-Ee, Shane Loretz

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 26 Sep 2019 00:00:00 -0000

ros-foxy-robot-state-publisher (2.2.4-1focal) focal; urgency=high

  * Remove unused Eigen3 dependency (#27 <https://github.com/ros2/robot_state_publisher/issues/27>) (#29 <https://github.com/ros2/robot_state_publisher/issues/29>)
  * Don't export exe as library (#25 <https://github.com/ros2/robot_state_publisher/issues/25>) (ros2 #28 <https://github.com/ros2/robot_state_publisher/issues/28>)
  * Contributors: Shane Loretz

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 06 Sep 2019 00:00:00 -0000

ros-foxy-robot-state-publisher (2.2.3-1focal) focal; urgency=high

  * Use rclcpp::Time for stamping transforms (#20 <https://github.com/ros2/robot_state_publisher/issues/20>)
  * Contributors: Scott K Logan

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 12 Jun 2019 00:00:00 -0000

ros-foxy-robot-state-publisher (2.2.2-1focal) focal; urgency=high

  * changes to avoid deprecated API's (#19 <https://github.com/ros2/robot_state_publisher/issues/19>)
  * Contributors: William Woodall

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 08 May 2019 00:00:00 -0000

ros-foxy-robot-state-publisher (2.2.1-1focal) focal; urgency=high

  * Updated to avoid deprecated API. (#18 <https://github.com/ros2/robot_state_publisher/issues/18>)
  * Contributors: William Woodall

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 26 Apr 2019 00:00:00 -0000

ros-foxy-robot-state-publisher (2.2.0-1focal) focal; urgency=high

  * Set urdf content as parameter. (#15 <https://github.com/ros2/robot_state_publisher/issues/15>)
  * Contributors: Karsten Knese

 -- Karsten Knese <karsten@osrfoundation.org>  Sun, 14 Apr 2019 00:00:00 -0000

ros-foxy-robot-state-publisher (2.1.0-1focal) focal; urgency=high

  * The robot model is now published on the ``robot_description`` topic as a ``std_msgs/String.msg``. (#9 <https://github.com/ros2/robot_state_publisher/issues/9>)
  * Contributors: Brett, Mikael Arguedas

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 27 Jun 2018 00:00:00 -0000

ros-foxy-robot-state-publisher (1.13.4-1focal) focal; urgency=high

  * Use ``urdf::*ShredPtr`` instead of ``boost::shared_ptr`` (#60 <https://github.com/ros/robot_state_publisher/issues/60>)
  * Error log for empty JointState.position was downgraded to a throttled warning (#64 <https://github.com/ros/robot_state_publisher/issues/64>)
  * Contributors: Jochen Sprickerhof, Sébastien BARTHÉLÉMY

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 05 Jan 2017 00:00:00 -0000

ros-foxy-robot-state-publisher (1.13.3-1focal) focal; urgency=high

  * Added a new parameter "ignore_timestamp" (#65 <https://github.com/ros/robot_state_publisher/issues/65>)


=== debian/control ===
Source: ros-foxy-robot-state-publisher
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-builtin-interfaces, ros-foxy-geometry-msgs, ros-foxy-kdl-parser, ros-foxy-launch-ros, ros-foxy-launch-testing-ament-cmake, ros-foxy-orocos-kdl, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2-ros, ros-foxy-urdf, ros-foxy-urdfdom-headers, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-robot-state-publisher
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-builtin-interfaces, ros-foxy-geometry-msgs, ros-foxy-kdl-parser, ros-foxy-orocos-kdl, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-sensor-msgs, ros-foxy-std-msgs, ros-foxy-tf2-ros, ros-foxy-urdf, ros-foxy-urdfdom-headers, ros-foxy-ros-workspace
Description: This package allows you to publish the state of a robot to tf2.
 Once the state gets published, it is available to all components in the system that also use tf2. The package takes the joint angles of the robot as input and publishes the 3D poses of the robot links, using a kinematic tree model of the robot.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-robot-state-publisher//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
